package com.supermap.sample.extendREST;

import java.util.HashMap;
import java.util.Map;

import org.restlet.Context;
import org.restlet.Request;
import org.restlet.Response;

import com.supermap.services.components.commontypes.Point2D;
import com.supermap.services.rest.HttpError;
import com.supermap.services.rest.resources.SimpleAlgorithmResultResourceBase;

public class CenterResource extends SimpleAlgorithmResultResourceBase {

	public CenterResource(Context context, Request request, Response response) {
		super(context, request, response);
	}

	//The type of the algorithm parameter, i.e., the structure of the request parameter
	@Override
	protected Map<String, Class> createArithParamClassMappings() {
        java.util.Map<String, Class> paramClassMapping = new HashMap<String, Class>();
        paramClassMapping.put("pointA", Point2D.class);
        paramClassMapping.put("pointB", Point2D.class);
        return paramClassMapping;
	}

	@Override
	protected Object runArithMetic(Map params) {
		if(params!=null){
			Point2D pA = (Point2D)params.get("pointA");
			Point2D pB = (Point2D)params.get("pointB");
			if(pA!=null&pB!=null){
				return new Point2D((pA.x+pB.x)/2,(pA.y+pB.y)/2);
			}
    	}
		return new HttpError(400,"Incomplete parameter");
	}

	@Override
	public boolean isResourceExist() {
		// 示例中设该资源一直存在
	    // The resource always exist
		return true;
	}

	@Override
	protected void checkUrlParamValid(Map params) {
		// TODO Auto-generated method stub
	}
}
