package com.supermap.sample.extendREST;
import java.util.ArrayList;
import java.util.List;

import org.restlet.data.MediaType;
import org.restlet.representation.Representation;

import com.supermap.services.rest.encoders.JsonEncoder;

public class MyEncoder extends JsonEncoder{
	public Representation toRepresentation(MediaType mediaType, Object resourceObj) {
		//得到表述内容，内容跟JSON表述生成器转换得到的内容一致。
	    //Get the representation consistent to that got from the JSON encoder
		Representation rep = super.toRepresentation(mediaType, resourceObj);
		if(rep != null){
			//设置 HTTP 响应中的媒体类型为 application/cjson。
		    //Set the media type in HTTP response to application/cjson
			rep.setMediaType(new MediaType("application/cjson"));
		}
		return rep ;
	}
	protected List<MediaType> createSupportedMediaTypes() {
        List<MediaType> supportedMediaTypes = new ArrayList<MediaType>(); // NOPMD
        //MyEncoder 表述生成器支持的媒体类型为 application/cjson
        //The media type supported by MyEncoder is application/cjson
        supportedMediaTypes.add(new MediaType("application/cjson"));
        return supportedMediaTypes;
    }
}
