package com.supermap.sample.extendREST;

import org.restlet.Request;
import org.restlet.Response;
import org.restlet.data.Status;
import org.restlet.representation.Representation;
import org.restlet.representation.Variant;

import com.supermap.services.rest.AbstractMethodHandler;
import com.supermap.services.rest.encoders.Encoder;
import com.supermap.services.rest.resources.ResourceBase;

public class SampleMethodHandler extends AbstractMethodHandler {

	@Override
	public void handleGet(ResourceBase targetResource, Request request, Response response) {
		  // 根据对资源的请求获取合适的表述生成器
          // Get the right encoder according to the request for the resource
		  Variant preferredVar = targetResource.getPreferredVariant();
	      Encoder encoder = targetResource.getAdaptedEncoder(preferredVar.getMediaType());
	        if (targetResource.isResourceExist()) {
	            Object content = targetResource.getResourceContent();
	            if (content != null) {
	            	//将响应结果放入 SampleResult 中返回
	                //Place the response in SampleResult and return it
	            	SampleResult sampleresult=new SampleResult(content,"I am a Sample Response.");
	                Representation entity = encoder.toRepresentation(preferredVar.getMediaType(), sampleresult);
	                response.setEntity(entity);
	                response.setStatus(Status.SUCCESS_OK);
	            } else {
	                // 资源没有表示。
	                // The resource has no representation
	                response.setStatus(Status.SUCCESS_NO_CONTENT);
	            }
	        } else {
	            // 处理资源不存在异常。
	            // The resource cannot be found
	        	response.setStatus(Status.CLIENT_ERROR_NOT_FOUND);
	        }
	}
	@Override
	public void handleHead(ResourceBase arg0, Request arg1, Response arg2) {
		// TODO Auto-generated method stub

	}
	@Override
	public void handleOptions(ResourceBase arg0, Request arg1, Response arg2) {
		// TODO Auto-generated method stub

	}
	@Override
	public void handlePost(ResourceBase arg0, Request arg1, Response arg2) {
		// TODO Auto-generated method stub

	}
	@Override
	public void handlePut(ResourceBase arg0, Request arg1, Response arg2) {
		// TODO Auto-generated method stub

	}
	@Override
	public void handleDelete(ResourceBase arg0, Request arg1, Response arg2) {

	}
}
