package com.supermap.sample.extendREST;
import java.util.ArrayList;
import java.util.List;

import org.restlet.data.MediaType;
import org.restlet.representation.Representation;
import org.restlet.representation.StringRepresentation;

import com.supermap.services.components.commontypes.Unit;
import com.supermap.services.components.commontypes.MeasureResult;
import com.supermap.services.rest.encoders.Encoder;

public class SpecialEncoder extends Encoder{
	public Representation toRepresentation(MediaType mediaType, Object resourceObj) {
		String repstr="";
		if(resourceObj instanceof MeasureResult){
			MeasureResult result=(MeasureResult)resourceObj;

			repstr="Area: "+result.area+" "+this.getUnit(result.unit);
		}else{
			repstr="Measurement error";
		}
		StringRepresentation rep=new StringRepresentation(repstr,MediaType.TEXT_PLAIN);
		return rep ;
	}
	protected List<MediaType> createSupportedMediaTypes() {
        List<MediaType> supportedMediaTypes = new ArrayList<MediaType>(); // NOPMD
        supportedMediaTypes.add(new MediaType("application/str"));
        return supportedMediaTypes;
    }
	private String getUnit(Unit unit){
		switch(unit){
			case KILOMETER:
				return "Square kilometers";
			case METER:
				return "Square meters";
			case DECIMETER:
				return "Square decimeters";
			case CENTIMETER:
				return "Square centimeters";
			case MILIMETER:
				return "Square millimeters";
			case MILE:
				return "Square miles";
			case FOOT:
				return "Square feet";
			case INCH:
				return "Square inches";
			case YARD:
				return "Square yards";
		}
		return "";
	}
}
